ff6046
From 34a38e3632fc504b55847fb9658788ccf5d42dad Mon Sep 17 00:00:00 2001
ff6046
From: Evgeny Vereshchagin <evvers@ya.ru>
ff6046
Date: Thu, 5 Jul 2018 04:09:30 +0000
ff6046
Subject: [PATCH] tests: create the asan wrapper automatically if systemd has
ff6046
 been built with ASAN
ff6046
ff6046
(cherry picked from commit ec9181d2ce4c0ad8b1c70b16a2b02a2667b1cc05)
ff6046
---
ff6046
 test/test-functions | 24 ++++++++++++++++++++++++
ff6046
 1 file changed, 24 insertions(+)
ff6046
ff6046
diff --git a/test/test-functions b/test/test-functions
ff6046
index e69420aeca..4417301be9 100644
ff6046
--- a/test/test-functions
ff6046
+++ b/test/test-functions
ff6046
@@ -28,6 +28,27 @@ STATEDIR="${BUILD_DIR:-.}/test/$(basename $(dirname $(realpath $0)))"
ff6046
 STATEFILE="$STATEDIR/.testdir"
ff6046
 TESTLOG="$STATEDIR/test.log"
ff6046
 
ff6046
+is_built_with_asan() {
ff6046
+    if ! type -P objdump >/dev/null; then
ff6046
+        ddebug "Failed to find objdump. Assuming systemd hasn't been built with ASAN."
ff6046
+        return 1
ff6046
+    fi
ff6046
+
ff6046
+    # Borrowed from https://github.com/google/oss-fuzz/blob/cd9acd02f9d3f6e80011cc1e9549be526ce5f270/infra/base-images/base-runner/bad_build_check#L182
ff6046
+    local _asan_calls=$(objdump -dC $BUILD_DIR/systemd | egrep "callq\s+[0-9a-f]+\s+<__asan" -c)
ff6046
+    if (( $_asan_calls < 1000 )); then
ff6046
+        return 1
ff6046
+    else
ff6046
+        return 0
ff6046
+    fi
ff6046
+}
ff6046
+
ff6046
+IS_BUILT_WITH_ASAN=$(is_built_with_asan && echo yes || echo no)
ff6046
+
ff6046
+if [[ "$IS_BUILT_WITH_ASAN" = "yes" ]]; then
ff6046
+    STRIP_BINARIES=no
ff6046
+fi
ff6046
+
ff6046
 function find_qemu_bin() {
ff6046
     # SUSE and Red Hat call the binary qemu-kvm. Debian and Gentoo call it kvm.
ff6046
     # Either way, only use this version if we aren't running in KVM, because
ff6046
@@ -217,6 +238,9 @@ setup_basic_environment() {
ff6046
     strip_binaries
ff6046
     install_depmod_files
ff6046
     generate_module_dependencies
ff6046
+    if [[ "$IS_BUILT_WITH_ASAN" = "yes" ]]; then
ff6046
+         create_asan_wrapper
ff6046
+    fi
ff6046
 }
ff6046
 
ff6046
 setup_selinux() {